module HP
  module Cloud
    module Mangler
      module Settings
        require 'multi_json'
        extend self

        @_settings = {}
        attr_reader :_settings
        # This is the main point of entry - we call Settings.load! and provide
        # a name of the file to read as it's argument. We can also pass in some
        # options.
        def load!(filename, options = {})
          @_settings = MultiJson.decode(IO.read(filename), :symbolize_names => true).merge options
        end
      end
    end
  end
end